/*
७ (Roll) -    ࠢ   ( 砬),  
  室饩  १      뫮.

 (Pitch) -        ,      室饩  १ .

 ᪠ (Yaw) -     襨.
*/


#ifndef vector3D
struct vector3D
{
float x, y, z;
};
#endif




// 
struct camera
{
	CQUATERNION q;      //x, y, z, w
	Matrix matrix;
	Matrix transpose;
	float position[3];      //
	float translate[3];     //
	float yaw, pitch, roll;
	CPlane frustum[6]; // view frustum planes
	float kick;
	//--------------------------------


	void Clear();
	void Update();



        	/**
		 * Performs a yaw rotation.
		 *
		 * @param theta Number of degrees to rotate.
		 */
		void RotateYaw(float theta);



		/**
		 * Performs a roll rotation.
		 *
		 * @param theta Number of degrees to rotate.
		 */
		void RotateRoll(float theta);

		/**
		 * Performs a pitch rotation.
		 *
		 * @param theta Number of degrees to rotate.
		 */
		void RotatePitch(float theta);

		/**
		 * Translates the Camera's current position.
		 *
		 * @param x x value to add to Camera's x position.
		 * @param y y value to add to Camera's y position.
		 * @param z z value to add to Camera's z position.
		 */
		void TranslatePosition(float x, float y, float z);




           	/**
		 * Sets the Camera's translation Vector, which is added to the Camera's position Vector during Matrix generation.
                 This is handy if, for example, the Camera view should be a bit above the ground if its Z position is 0.
		 *
		 * @param v Translation Vector.
		 */
		void SetTranslation(int unsigned v);
                void SetTranslation2(float x, y, z);

		int unsigned GetLpTranslate();

	         /**
 		 * @return Pointer to Camera's view Matrix.
		 */
		int unsigned GetMatrix();




		/**
		 * @return Pointer to Camera's transpose view Matrix. The tranpose Matrix is useful for things like billboarding.
		 */
		int unsigned GetTransposeMatrix();



};


void camera::Clear(){


	translate[0]=translate[1]=translate[2]=0.0f;
	position[0]=position[1]=position[2]=0.0f;

	yaw = 0.0f;
	pitch = 0.0f;
	roll = 0.0f;
	kick = 0.0f;

        Update();


}
//-------------------------------------------------------------------------------------------------





void camera::Update()
{

//       float Euler[3];

       float p, c, s;

	Matrix r_matrix;
	Matrix t_matrix;


	// pitch rotation
	r_matrix.LoadIdentity();


	p = DEG2RAD(pitch);
	c = cosf(p);
	s = sinf(p);

	r_matrix.mat[5] = c;
	r_matrix.mat[6] = -s;
	r_matrix.mat[9] = s;
	r_matrix.mat[10] = c;


	t_matrix.LoadIdentity();
	t_matrix.mat[3]  = -position[0] + translate[0];
	t_matrix.mat[7]  = -position[1] + translate[1];
	t_matrix.mat[11] = -position[2] + translate[2];


	// yaw/roll rotation
//	q.Rotate(90.0f, yaw, roll);
//     	q.ToMatrix(&matrix);

//** Convert Euler angles to quaternion
// Note: camera must be properly initialized before calling this
// IN:  ESI=ptr to angles  ࠤ  float
// OUT: EBX=ptr to resulting quaternion
//quat_Angles2Quaternion(ESI, EBX)
//Euler[0]=90.0f;  Euler[1]=yaw;  Euler[2]=roll;
//Euler[0]=90.0f;  Euler[1]=0.0;  Euler[2]=0.0;

//ॢ 㫥 ࠤ  ୨
//quat_Angles2Quaternion(#Euler, #q);
//ॢ   饭

//quat_Rotate(90.0, 0.0, 0.0, #q);

quat_Rotate(pitch, yaw, roll, #q);

// ୨   饭 OpenGL
//ECX 㪠⥫  ୨
//ESI 㪠⥫    4x4
//fastcall quat_CreateMatrix(ECX, ESI)
quat_CreateMatrix(#q, #matrix);



	t_matrix.mat[3] -= matrix.mat[8] * kick; // kick
	t_matrix.mat[7] -= matrix.mat[9] * kick;
	t_matrix.mat[11] -= matrix.mat[10] * kick;

	matrix.Multiply(#t_matrix);
	r_matrix.Multiply(#matrix);

//	matrix = r_matrix;
	matrix.Set(#r_matrix);

	// convert matrices to the order that OpenGL likes
	transpose.Set(#matrix.mat);
	matrix.Transpose();


}


void camera::RotateYaw(float theta)
{
	yaw += theta;
}

void camera::RotateRoll(float theta)
{
	roll += theta;
}

void camera::RotatePitch(float theta)
{
	pitch += theta;

	IF(pitch > 90.0f)
		pitch = 90.0f;

	ELSE IF(pitch < -90.0f)
		pitch = -90.0f;
}

void camera::TranslatePosition(float x, float y, float z)
{
	position[0] += x;
	position[1] += y;
	position[2] += z;
}


void camera::SetTranslation(int unsigned v)
{
EBX=v;

translate[0]=EBX.vector3D.x;
translate[1]=EBX.vector3D.y;
translate[2]=EBX.vector3D.z;



}


void camera::SetTranslation2(float x, y, z)
{

translate[0]=x;
translate[1]=y;
translate[2]=z;


}


int unsigned camera::GetLpTranslate()
{
EAX=#translate;
}


int unsigned camera::GetMatrix() { return #matrix; }

int unsigned camera::GetTransposeMatrix() { return #transpose; }


