
/* Graphics Library Helper aka glh
** This is version 1.53
** The latest can be found at
** http://www.geocities.com/vmelkon/glhlibrary.html
** By Vrej Melkonian
** vmelkon@yahoo.com
** Copyright (C) 2001-2004 Vrej Melkonian All Rights Reserved.
**
** The Readme.txt file that comes with the ZIP file (glhlib_153.zip) contains
** some information as to how to use this library. Description of each function
** is given below.
**
** The Copyright.txt file that comes with the ZIP file (glhlib_153.zip) contains
** some legal information about this library.
**
** This library is updated often on my own machine, as the need arises
** so updates are not regularly available on the web page.
** Updates to the web page are only made when a significant amount
** of new functionality is added.
*/




/*Global stuff*/
#ifndef NULL
#define NULL		0
#endif





           	
/*Defines -start*/

/*Part 1*/
#define GLH_ENGLISH			0x000186A0

#define GLH_VERSION			0x000186A0
#define GLH_EXTENSIONS		0x000186A1
#define GLH_URL				0x000186A2
#define GLH_DESCRIBE		0x000186A3

/*Part 2*/
#define	GLH_MATRIXSTACK_API_DEPTH		0x000000A0
#define GLH_MATRIXSTACK_MAX_DEPTH		0x000000A1
#define GLH_MATRIXSTACK_CURRENT_DEPTH	0x000000A2
#define GLH_MATRIXSTACK_TOP_MATRIX		0x000000A3

#define GLH_ERROR_NONE					0xF0000000
#define GLH_ERROR_OUT_OF_MEMORY			0xF0000001
#define GLH_ERROR_INVALID_PARAM			0xF0000002
#define GLH_ERROR_INVALID_INDEX			0xF0000003
#define GLH_ERROR_INVALID_ID			0xF0000004
#define GLH_ERROR_INVALID_VALUE			0xF0000005
#define GLH_ERROR_STACK_OVERFLOW		0xF0000006
#define GLH_ERROR_STACK_UNDERFLOW		0xF0000007

#define GLH_MODE_NONE						0x01000000
#define GLH_MODE_STANDARD					0x0100000F
#define GLH_MODE_ALTERNATE					0x010000F0
#define GLH_MODE_ALTERNATE2					0x010000F1
#define GLH_MODE_ALTERNATE3					0x010000F2
#define GLH_MODE_ALTERNATE4					0x010000F3
#define GLH_INTERPOLATIONQUALITY_LINEAR		0xF0000001
#define GLH_INTERPOLATIONQUALITY_COS		0xF0000002

#define	GLH_OPTIMIZE_NONE					0x00100000
#define	GLH_OPTIMIZE_MMX_SSE				0x0010000F


#define	GLH_SHADERTYPE_PS_1_0			0x02000000
#define	GLH_SHADERTYPE_PS_1_1			0x02000001
#define	GLH_SHADERTYPE_PS_1_2			0x02000002
#define	GLH_SHADERTYPE_PS_1_3			0x02000003
#define	GLH_SHADERTYPE_PS_1_4			0x02000004
#define	GLH_SHADERTYPE_PS_2_0			0x0200000A
#define GLH_SHADERTYPE_ARBFP_1_0		0x02000010


#define GLHLIB_API stdcall


extern WINAPI "glhlib.dll"
{

/*Defines -end*/

/*Block 0 -start*/
/*Block 0 -end*/


/*Block 1 -start*/


//PURPOSE:	Get some info about the glh library. See section Defines Part 1
int unsigned  GLHLIB_API glhGetString(GLenum language, GLenum token);
/*Block 1 -end*/

//PURPOSE:	glh stores a table of random number dedicated to the perlin noise
//			generator. If you want new numbers in the table, call this.
void GLHLIB_API glhPerlinRegenerateTable();

GLint GLHLIB_API glhPerlinNoise2D(int unsigned result, GLint interpolationQuality, GLint mode, GLint optimize, int unsigned pos, GLfloat persistence, GLint numberOfOctaves, int unsigned boolOctave);


}


