#ifndef f2_0
float f2_0=2.0f;
#endif

#ifndef bool
#define bool BOOLEAN
#endif

#ifndef true
#define true TRUE
#endif

#ifndef false
#define false FALSE
#endif


//  

struct sprite {
   // Sprite Controls...

    float  m_fPositionX;
    float  m_fPositionY;
    float  m_fWidth;
    float  m_fHeight;
    float  m_fRotation;
    float  m_fAlpha;

    // Texture Animation Settings...

    int m_textureID;
    float  m_fFrameDelay;
    int    m_nNumFrameColumns;
    int    m_nNumFrameRows;
    int    m_nTotalFrames;
    int    m_nTextureWidth;
    int    m_nTextureHeight;
    int    m_nFrameWidth;
    int    m_nFrameHeight;
    int    m_nOffsetX;
    int    m_nOffsetY;

    // Frame tracking variables...

    int    m_nFrameNumber;
    int    m_nCurrentRow;
    int    m_nCurrentColumn;
	  float  m_lastTime;
    bool   m_bFirstRendering;

		sprite();
		~sprite();

   void setPosition(float fPositionX, float fPositionY);
	 void setSize(float fWidth, float fHeight);

   void  setPositionX(float fPositionX);
   float getPositionX();

    void  setPositionY(float fPositionY);
    float getPositionY();

	void  setWidth(float fWidth);
    float getWidth();

    void  setHeight(float fHeight);
    float getHeight();

    void  setRotation(float fRotation);
    float getRotation();

    void  setAlpha(float fAlpha);
    float getAlpha();

    void  setTextureID(int textureID);
    int   getTextureID();

    void  setTextureWidth(int nTextureWidth);
    int   getTextureWidth();

    void  setTextureHeight(int nTextureHeight);
    int   getTextureHeight();

    void  setFrameWidth(int nFrameWidth);
    int   getFrameWidth();

    void  setFrameHeight(int nFrameHeight);
    int   getFrameHeight();

    void  setNumFrameColumns(int nNumFrameColumns);
    int   getNumFrameColumns();

    void  setNumFrameRows (int nNumFrameRows);
    int   getNumFrameRows ();

    void  setTotalFrames(int nTotalFrames);
    int   getTotalFrames();

    void  setOffsetX(int nOffsetX);
    int   getOffsetX();

    void  setOffsetY(int nOffsetY);
    int   getOffsetY();

    void  setFrameDelay( float fFrameDelay );
    float getFrameDelay();


	 void  setTextureAnimeInfo( int nTextureWidth, int nTextureHeight,
                               int nFrameWidth,   int nFrameHeight,
                               int nNumFrameColumns, int nNumFrameRows,
                               int nTotalFrames,
                               int nOffsetX, int nOffsetY);
    void render(float t);

};
//-------------------------------------------------------------
sprite::sprite()
{
	 m_fPositionY = 0.0f;
    m_fPositionX = 0.0f;
    m_fWidth     = 1.0f;
    m_fHeight    = 1.0f;
    m_fAlpha     = 1.0f;
    m_textureID  = 0;
    m_fRotation  = 0.0f;

    m_nNumFrameColumns = 1;
    m_nNumFrameRows    = 1;
    m_nTotalFrames     = 1;

    m_nTextureWidth  = 256;
    m_nTextureHeight = 256;
    m_nFrameWidth    = 256;
    m_nFrameHeight   = 256;
    m_nOffsetX       = 0;
    m_nOffsetY       = 0;

    m_nFrameNumber    = 0;
    m_nCurrentRow     = 0;
    m_nCurrentColumn  = 0;
    m_bFirstRendering = true;
		//m_lastTime=0.0;

}

//----------------------------------------------------------------------------------
sprite::~sprite()
{

}
//------------------------------------------------------------------------
 void sprite::setPosition(float fPositionX, float fPositionY)
 {
	      m_fPositionX = fPositionX;
        m_fPositionY = fPositionY;

 }

//---------------------------------------------------------------------------
 void sprite::setSize(float fWidth, float fHeight)
    {
        m_fWidth  = fWidth;
        m_fHeight = fHeight;
    }


//----------------------------------------------------------------------
void  sprite::setPositionX(float fPositionX) { m_fPositionX = fPositionX; }
 float sprite::getPositionX() { return m_fPositionX; }
//--------------------------------------------------------------------------
 void sprite:: setPositionY(float fPositionY) { m_fPositionY = fPositionY; }
 float sprite::getPositionY() { return m_fPositionY; }
 //----------------------------------------------------------------------------
  void  sprite::setWidth(float fWidth) { m_fWidth = fWidth; }
    float sprite::getWidth() { return m_fWidth; }

    void  sprite::setHeight(float fHeight) { m_fHeight = fHeight; }
    float sprite::getHeight() { return m_fHeight; }

    void  sprite::setRotation(float fRotation) { m_fRotation = m_fRotation; }
    float sprite::getRotation() { return m_fRotation; }

    void  sprite::setAlpha(float fAlpha) { m_fAlpha = fAlpha; }
    float sprite::getAlpha() { return m_fAlpha; }

    void  sprite::setTextureID(int textureID) { m_textureID = textureID; }
    int   sprite::getTextureID() { return m_textureID; }

    void  sprite::setTextureWidth(int nTextureWidth) { m_nTextureWidth = nTextureWidth; }
    int   sprite::getTextureWidth() { return m_nTextureWidth; }

    void  sprite::setTextureHeight(int nTextureHeight) { m_nTextureHeight = nTextureHeight; }
    int   sprite::getTextureHeight() { return m_nTextureHeight; }

    void  sprite::setFrameWidth(int nFrameWidth) { m_nFrameWidth = nFrameWidth; }
    int   sprite::getFrameWidth() { return m_nFrameWidth; }

    void  sprite::setFrameHeight(int nFrameHeight) { m_nFrameHeight = nFrameHeight; }
    int   sprite::getFrameHeight() { return m_nFrameHeight; }

    void  sprite::setNumFrameColumns(int nNumFrameColumns) { m_nNumFrameColumns = nNumFrameColumns; }
    int   sprite::getNumFrameColumns() { return m_nNumFrameColumns; }

    void  sprite::setNumFrameRows (int nNumFrameRows) { m_nNumFrameRows = nNumFrameRows; }
    int   sprite::getNumFrameRows () { return m_nNumFrameRows; }

    void  sprite::setTotalFrames(int nTotalFrames) { m_nTotalFrames = nTotalFrames; }
    int   sprite::getTotalFrames() { return m_nTotalFrames; }

    void  sprite::setOffsetX(int nOffsetX) { m_nOffsetX = nOffsetX; }
    int   sprite::getOffsetX() { return m_nOffsetX; }

    void  sprite::setOffsetY(int nOffsetY) { m_nOffsetY = nOffsetY; }
    int   sprite::getOffsetY() { return m_nOffsetY; }

    void  sprite::setFrameDelay( float fFrameDelay ) { m_fFrameDelay = fFrameDelay; }
    float sprite::getFrameDelay() { return m_fFrameDelay; }


//-------------------------------------------------------------
void sprite::setTextureAnimeInfo( int nTextureWidth, int nTextureHeight,
                               int nFrameWidth,   int nFrameHeight,
                               int nNumFrameColumns, int nNumFrameRows,
                               int nTotalFrames,
                               int nOffsetX, int nOffsetY)
{

      	m_nTextureWidth         = nTextureWidth;
        m_nTextureHeight        = nTextureHeight;
        m_nFrameWidth           = nFrameWidth;
        m_nFrameHeight           = nFrameHeight;
        m_nNumFrameColumns  = nNumFrameColumns;
        m_nNumFrameRows      = nNumFrameRows;
        m_nTotalFrames           = nTotalFrames;
        m_nOffsetX                 = nOffsetX;
        m_nOffsetY                 = nOffsetY;

}
//---------------------------------------------------------------

//t -    
    void sprite::render(float t)
		{
float currentTime;
float fSubRange_s;
float fSubRange_t;
float fFrame_s;
float fFrame_t;
float fLowerLeft_s;
float fLowerLeft_t;
float fLowerRight_s;
float fLowerRight_t;
float fUpperRight_s;
float fUpperRight_t;
float fUpperLeft_s;
float fUpperLeft_t;
float fOffset_s;
float fOffset_t;
float fRelativeX;
float fRelativeY;
float  fElapsed = 0.0f;


 IF( m_bFirstRendering == true )
    {

        currentTime = m_lastTime;
        m_bFirstRendering = false;
    } ELSE
    {
		currentTime=t;

        fElapsed = currentTime - m_lastTime;
    }


//-------------------------------------------------------------------------
    // OpenGL Texture Coordinate Layout for a simple quad
    //
    // (Upper Left)  0.0, 1.0             1.0, 1.0  (Upper Right)
    //                        +---------+
    //                        |         |
    //                        |         |
    //                        |         |
    //                        |         |
    //                        +---------+
    // (Lower Left)  0.0, 0.0             1.0, 0.0  (Lower Right)
    //-------------------------------------------------------------------------

    // If the frames of animation don't fill up the whole texture, you'll need
    // to find the sub-range within the standard texture range (0.0 to 1.0)
    // that the frames do exist within.
//    float fSubRange_s = (1.0f / m_nTextureWidth ) *
//                        (m_nFrameWidth  * m_nNumFrameColumns);
  $fild m_nFrameWidth
	$fimul m_nNumFrameColumns
	$fld1
	$fidiv m_nTextureWidth
	$fmulp st(1)
	$fstp fSubRange_s


//    float fSubRange_t = (1.0f / m_nTextureHeight) *
//                        (m_nFrameHeight * m_nNumFrameRows);
   $fild m_nFrameHeight
	 $fimul m_nNumFrameRows
	 $fld1
	 $fidiv m_nTextureHeight
	 $fmulp st(1)
	 $fstp fSubRange_t


    // No convert the Width and Height of a frame into texture values...
//    float fFrame_s = fSubRange_s / m_nNumFrameColumns;

   $fld fSubRange_s
	 $fidiv m_nNumFrameColumns
	 $fstp fFrame_s

//    float fFrame_t = fSubRange_t / m_nNumFrameRows;
    $fld fSubRange_t
		$fidiv m_nNumFrameRows
		$fstp fFrame_t


    // Now, calculate the new s/t texture values for the four corners
    // of the quad based on the current column and row of the animation
//    float fLowerLeft_s  = m_nCurrentColumn * fFrame_s;
    $fild m_nCurrentColumn
		$fmul fFrame_s
		$fstp fLowerLeft_s

//float fLowerLeft_t  = 1.0f - (m_nCurrentRow * fFrame_t) - fFrame_t;
		$fld1
    $fild m_nCurrentRow
		$fmul fFrame_t
    $fsubp st(1)
		$fsub fFrame_t
    $fstp fLowerLeft_t

//float fLowerRight_s = (m_nCurrentColumn * fFrame_s) + fFrame_s;
     $fild m_nCurrentColumn
		 $fmul fFrame_s
		 $fadd fFrame_s
		 $fstp fLowerRight_s

//    float fLowerRight_t = 1.0f - (m_nCurrentRow * fFrame_t) - fFrame_t;
     $fld1
     $fild m_nCurrentRow
		 $fmul fFrame_t
		 $fsubp st(1)
     $fsub fFrame_t
     $fstp fLowerRight_t

//float fUpperRight_s = (m_nCurrentColumn * fFrame_s) + fFrame_s;
     $fild m_nCurrentColumn
		 $fmul fFrame_s
		 $fadd fFrame_s
		 $fstp fUpperRight_s

//    float fUpperRight_t = 1.0f - (m_nCurrentRow * fFrame_t);
	   $fld1
		 $fild m_nCurrentRow
		 $fmul fFrame_t
		 $fsubp st(1)
		 $fstp fUpperRight_t

//	float fUpperLeft_s  = m_nCurrentColumn * fFrame_s;
     $fild m_nCurrentColumn
		 $fmul fFrame_s
		 $fstp fUpperLeft_s

//    float fUpperLeft_t  = 1.0f - (m_nCurrentRow * fFrame_t);
      $fld1
      $fild m_nCurrentRow
			$fmul fFrame_t
			$fsubp st(1)
			$fstp fUpperLeft_t

    // Apply an offset into texture if the first frame is not located
    // in the upper left corner of the texture as normal.

    IF( m_nOffsetX > 0) || (m_nOffsetY > 0 )
    {
//        float fOffset_s = (1.0f / m_nTextureWidth ) * m_nOffsetX;
      $fld1
			$fidiv m_nTextureWidth
			$fimul m_nOffsetX
			$fstp fOffset_s

//        float fOffset_t = (1.0f / m_nTextureHeight) * m_nOffsetY;
		  $fld1
			$fidiv m_nTextureHeight
			$fimul m_nOffsetY
			$fstp fOffset_t

	fLowerLeft_s  += fOffset_s;
  fLowerLeft_t  -= fOffset_t;

	fLowerRight_s += fOffset_s;
  fLowerRight_t -= fOffset_t;

	fUpperRight_s += fOffset_s;
  fUpperRight_t -= fOffset_t;

	fUpperLeft_s  += fOffset_s;
  fUpperLeft_t  -= fOffset_t;



		}

/*
    // We know where the sprite's center is at, now half its width and height
    // to find where its four corners should be placed for generating a GL_QUAD.
    float fRelativeX = (m_fWidth  / 2.0f);
    float fRelativeY = (m_fHeight / 2.0f);

   */

	 $fld m_fWidth
	 $fdiv f2_0
	 $fstp fRelativeX

	 $fld m_fHeight
	 $fdiv f2_0
	 $fstp fRelativeY


		    // Set up the rotation and translation matrices
    glPushMatrix();
    glTranslatef( m_fPositionX, m_fPositionY, 0.0f );
    glRotatef( m_fRotation, 0.0f, 0.0f, 1.0f );

    //
    // Push back and cache the current OpenGl state before changing it.
    //

    glPushAttrib( GL_TEXTURE_BIT | GL_DEPTH_TEST | GL_LIGHTING );

    glEnable( GL_TEXTURE_2D );
    glDisable( GL_DEPTH_TEST );
    glDisable( GL_LIGHTING );

    glEnable( GL_BLEND );
    glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );

    glEnable( GL_ALPHA_TEST );
    glAlphaFunc( GL_GREATER, 0 );

    glBindTexture( GL_TEXTURE_2D, m_textureID );

    glBegin( GL_QUADS );
    {
        glColor4f( 1.0f, 1.0f, 1.0f, m_fAlpha );
        glTexCoord2f(fLowerLeft_s, fLowerLeft_t);   // Lower Left of quad
        glVertex2f( -fRelativeX, -fRelativeY );

        glColor4f( 1.0f, 1.0f, 1.0f, m_fAlpha );
        glTexCoord2f(fLowerRight_s, fLowerRight_t); // Lower Right of quad
        glVertex2f( fRelativeX, -fRelativeY );

        glColor4f( 1.0f, 1.0f, 1.0f, m_fAlpha );
        glTexCoord2f(fUpperRight_s, fUpperRight_t); // Upper Right of quad
        glVertex2f( fRelativeX, fRelativeY );

        glColor4f( 1.0f, 1.0f, 1.0f, m_fAlpha );
        glTexCoord2f(fUpperLeft_s, fUpperLeft_t);   // Upper Left of quad
        glVertex2f(-fRelativeX, fRelativeY );
    }
    glEnd();

    glPopAttrib();

    // Pop the matrix that we pushed above
    glPopMatrix();
//--------------------------------


    // If the frame delay has elapsed, move on to the next frame of animation...
    IF( fElapsed >= m_fFrameDelay )
    {

        m_lastTime = currentTime;

        m_nCurrentColumn++;
        m_nFrameNumber++;

        IF( m_nCurrentColumn >= m_nNumFrameColumns )
        {
            m_nCurrentColumn = 0;
            m_nCurrentRow++;
        }

        IF( m_nCurrentRow >= m_nNumFrameRows )
        {
            m_nCurrentRow    = 0;
            m_nCurrentColumn = 0;
        }

       IF( m_nFrameNumber >= m_nTotalFrames )
        {
            m_nCurrentRow    = 0;
            m_nCurrentColumn = 0;
            m_nFrameNumber   = 0;
        }


    }// if

		}
