// 32  TGA RGBA  

#define bool BOOLEAN
#define true TRUE
#define false FALSE



struct tgaImageFile
{

    int    m_nImageWidth;
    int    m_nImageHeight;
    int    m_nImageBits;
    int    m_texFormat;
		unsigned int m_nImageData;


	bool checkSize(int x);

  unsigned int getRGBA( DWORD  s, int size );
  bool load( DWORD name );
  void Deload();
  int ID_TEX;
	void Texture();
   void DeTexture();
};


//-------------------------------------------
bool tgaImageFile::checkSize( int x )
{
    // Make sure its a power of 2.
		SWITCH(x){
    	CASE 2:
			CASE 4:
      CASE 8:
			CASE 16:
      CASE 32:
			CASE 64:
      CASE 128:
			CASE 256:
      CASE 512:
        RETURN true;
		}
    return false;
}
//-----------------------------------------------

//-------------------------------------------
unsigned int tgaImageFile::getRGBA( DWORD  s, int size )
{
	  // Read in RGBA data for a 32bit image.
    unsigned int rgba;
    int bread;

    rgba = malloc( size * 4 );

  IF( rgba == NULL )
        RETURN 0;

bread = fread( rgba, sizeof (unsigned char), size * 4, s );

    // TGA is stored in BGRA, make it RGBA
    IF( bread != size * 4 )
    {
        free( rgba );
        RETURN 0;
    }

// BGRA  RGBA
SwapRGBA(rgba,  size);


m_texFormat = GL_RGBA;
return rgba;

}

//---------------------------------------------

bool tgaImageFile::load( DWORD name )
{

	 // Loads up a targa file. Supported types are  32
    // uncompressed images.
    unsigned char type[4];
    unsigned char info[7];
    DWORD s = NULL;
    int size = 0;

    IF( !(s = fopen( name, "rb" )) )
        return 0;

    fread( #type, sizeof (char), 3, s );   // Read in colormap info and image type, byte 0 ignored
    fseek( s, 12, SEEK_SET);			   // Seek past the header and useless info
    fread( #info, sizeof (char), 6, s );

    m_nImageWidth  =  info[1] * 256 + info[0];
    m_nImageHeight =  info[3] * 256 + info[2];
    m_nImageBits   = info[4];

		 size = m_nImageWidth * m_nImageHeight;

		 // Make sure dimension is a power of 2

	  IF( !checkSize(m_nImageWidth)) || (!checkSize(m_nImageHeight))
       RETURN 0;

    // Make sure we are loading a supported type
    IF( m_nImageBits != 32)  RETURN 0;

    m_nImageData = getRGBA( s, size );

// No image data
    IF( m_nImageData == NULL ) RETURN 0;

		 fclose( s );
		 return true;

}
void tgaImageFile::Deload()
{
    IF( m_nImageData != NULL )
    {
        free( m_nImageData );
        m_nImageData = NULL;
    }
}

void tgaImageFile::Texture()
{
glGenTextures(1, #ID_TEX);
glBindTexture(GL_TEXTURE_2D, ID_TEX);
glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
gluBuild2DMipmaps(GL_TEXTURE_2D, m_texFormat, m_nImageWidth, m_nImageHeight, m_texFormat,
		GL_UNSIGNED_BYTE, m_nImageData);

/*
 glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

    glTexImage2D( GL_TEXTURE_2D, 0, m_texFormat,
                  m_nImageWidth, m_nImageHeight,
                  0, m_texFormat, GL_UNSIGNED_BYTE,
                  m_nImageData );
*/
}

void tgaImageFile::DeTexture()
{
	EAX=#ID_TEX;
glDeleteTextures(1, EAX);


}
